# Deprecated API

## Contents

- Interfaces
- Classes
- Exceptions
- Fields
- Methods

Interfaces
javax.servlet.jsp.el.FunctionMapper: As of JSP 2.1, replaced by javax.el.FunctionMapper
javax.servlet.jsp.el.VariableResolver: As of JSP 2.1, replaced by javax.el.ELResolver

Classes
javax.servlet.jsp.el.Expression: As of JSP 2.1, replaced by javax.el.ValueExpression
javax.servlet.jsp.el.ExpressionEvaluator: As of JSP 2.1, replaced by javax.el.ExpressionFactory

Exceptions
javax.servlet.jsp.el.ELException: As of JSP 2.1, replaced by javax.el.ELException
javax.servlet.jsp.el.ELParseException: As of JSP 2.1, replaced by javax.el.ELException

Fields
javax.servlet.jsp.tagext.BodyTag.EVAL_BODY_TAG: As of Java JSP API 1.2, use BodyTag.EVAL_BODY_BUFFERED or IterationTag.EVAL_BODY_AGAIN.

Methods
javax.servlet.jsp.JspContext.getExpressionEvaluator(): As of JSP 2.1, replaced by JspApplicationContext.getExpressionFactory()
javax.servlet.jsp.JspContext.getVariableResolver(): As of JSP 2.1, replaced by javax.el.ELContext.getELResolver() which can be obtained by jspContext.getELContext().getELResolver()
javax.servlet.jsp.JspException.getRootCause(): As of JSP 2.1, replaced by `java.lang.Throwable.getCause()`